Named Value - Create Or Update

Creates or updates named value.

PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ApiManagement/service/{serviceName}/namedValues/{namedValueId}?api-version=2021-08-01

URI Parameters

Name In Required Type Description
namedValueId
path True
  • string

Identifier of the NamedValue.

Regex pattern: ^[^*#&+:<>?]+$

resourceGroupName
path True
  • string

The name of the resource group.

serviceName
path True
  • string

The name of the API Management service.

Regex pattern: ^[a-zA-Z](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?$

subscriptionId
path True
  • string

Subscription credentials which uniquely identify Microsoft Azure subscription. The subscription ID forms part of the URI for every service call.

api-version
query True
  • string

Version of the API to be used with the client request.

Request Header

Name Required Type Description
If-Match
  • string

ETag of the Entity. Not required when creating an entity, but required when updating an entity.

Request Body

Name Required Type Description
properties.displayName True
  • string

Unique name of NamedValue. It may contain only letters, digits, period, dash, and underscore characters.

properties.keyVault

KeyVault location details of the namedValue.

properties.secret
  • boolean

Determines whether the value is a secret and should be encrypted or not. Default value is false.

properties.tags
  • string[]

Optional tags that when provided can be used to filter the NamedValue list.

properties.value
  • string

Value of the NamedValue. Can contain policy expressions. It may not be empty or consist only of whitespace. This property will not be filled on 'GET' operations! Use '/listSecrets' POST request to get the value.

Responses

Name Type Description
200 OK

Named value was successfully updated.

Headers

  • ETag: string
201 Created

Named value was successfully created.

Headers

  • ETag: string
202 Accepted

Request to create or update named value was accepted.

Other Status Codes

Error response describing why the operation failed.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

ApiManagementCreateNamedValue
ApiManagementCreateNamedValueWithKeyVault

ApiManagementCreateNamedValue

Sample Request

PUT https://management.azure.com/subscriptions/subid/resourceGroups/rg1/providers/Microsoft.ApiManagement/service/apimService1/namedValues/testprop2?api-version=2021-08-01

{
  "properties": {
    "displayName": "prop3name",
    "value": "propValue",
    "tags": [
      "foo",
      "bar"
    ],
    "secret": false
  }
}

Sample Response

location: https://management.azure.com/subscriptions/subid/resourceGroups/rg1/providers/Microsoft.ApiManagement/service/apimService1/namedValues/testprop2?api-version=2021-08-01&asyncId=5c730e343244df1b9cb56e85&asyncCode=201
{
  "id": "/subscriptions/subid/resourceGroups/rg1/providers/Microsoft.ApiManagement/service/apimService1/namedValues/testprop2",
  "type": "Microsoft.ApiManagement/service/namedValues",
  "name": "testprop2",
  "properties": {
    "displayName": "prop3name",
    "value": "propValue",
    "tags": [
      "foo",
      "bar"
    ],
    "secret": false
  }
}
{
  "id": "/subscriptions/subid/resourceGroups/rg1/providers/Microsoft.ApiManagement/service/apimService1/namedValues/testprop2",
  "type": "Microsoft.ApiManagement/service/namedValues",
  "name": "testprop2",
  "properties": {
    "displayName": "prop3name",
    "value": "propValue",
    "tags": [
      "foo",
      "bar"
    ],
    "secret": false
  }
}

ApiManagementCreateNamedValueWithKeyVault

Sample Request

PUT https://management.azure.com/subscriptions/subid/resourceGroups/rg1/providers/Microsoft.ApiManagement/service/apimService1/namedValues/testprop6?api-version=2021-08-01

{
  "properties": {
    "displayName": "prop6namekv",
    "keyVault": {
      "identityClientId": "ceaa6b06-c00f-43ef-99ac-f53d1fe876a0",
      "secretIdentifier": "https://contoso.vault.azure.net/secrets/aadSecret"
    },
    "tags": [
      "foo",
      "bar"
    ],
    "secret": true
  }
}

Sample Response

location: https://management.azure.com/subscriptions/subid/resourceGroups/rg1/providers/Microsoft.ApiManagement/service/apimService1/namedValues/testprop6?api-version=2021-08-01&asyncId=5c730e343244df1b9cb56e85&asyncCode=201
{
  "id": "/subscriptions/subid/resourceGroups/rg1/providers/Microsoft.ApiManagement/service/apimService1/namedValues/testprop6",
  "type": "Microsoft.ApiManagement/service/namedValues",
  "name": "testprop6",
  "properties": {
    "displayName": "prop6namekv",
    "keyVault": {
      "secretIdentifier": "https://contoso.vault.azure.net/secrets/aadSecret",
      "identityClientId": "ceaa6b06-c00f-43ef-99ac-f53d1fe876a0",
      "lastStatus": {
        "code": "Success",
        "timeStampUtc": "2020-09-11T00:54:31.8024882Z"
      }
    },
    "tags": [
      "foo",
      "bar"
    ],
    "secret": true
  }
}
{
  "id": "/subscriptions/subid/resourceGroups/rg1/providers/Microsoft.ApiManagement/service/apimService1/namedValues/testprop6",
  "type": "Microsoft.ApiManagement/service/namedValues",
  "name": "testprop6",
  "properties": {
    "displayName": "prop6namekv",
    "keyVault": {
      "secretIdentifier": "https://contoso.vault.azure.net/secrets/aadSecret",
      "identityClientId": "ceaa6b06-c00f-43ef-99ac-f53d1fe876a0",
      "lastStatus": {
        "code": "Success",
        "timeStampUtc": "2020-09-11T00:54:31.8024882Z"
      }
    },
    "tags": [
      "foo",
      "bar"
    ],
    "secret": true
  }
}

Definitions

ErrorFieldContract

Error Field contract.

ErrorResponse

Error Response.

KeyVaultContractCreateProperties

Create keyVault contract details.

KeyVaultContractProperties

KeyVault contract details.

KeyVaultLastAccessStatusContractProperties

Issue contract Update Properties.

NamedValueContract

NamedValue details.

NamedValueCreateContract

NamedValue details.

ErrorFieldContract

Error Field contract.

Name Type Description
code
  • string

Property level error code.

message
  • string

Human-readable representation of property-level error.

target
  • string

Property name.

ErrorResponse

Error Response.

Name Type Description
error.code
  • string

Service-defined error code. This code serves as a sub-status for the HTTP error code specified in the response.

error.details

The list of invalid fields send in request, in case of validation error.

error.message
  • string

Human-readable representation of the error.

KeyVaultContractCreateProperties

Create keyVault contract details.

Name Type Description
identityClientId
  • string

Null for SystemAssignedIdentity or Client Id for UserAssignedIdentity , which will be used to access key vault secret.

secretIdentifier
  • string

Key vault secret identifier for fetching secret. Providing a versioned secret will prevent auto-refresh. This requires API Management service to be configured with aka.ms/apimmsi

KeyVaultContractProperties

KeyVault contract details.

Name Type Description
identityClientId
  • string

Null for SystemAssignedIdentity or Client Id for UserAssignedIdentity , which will be used to access key vault secret.

lastStatus

Last time sync and refresh status of secret from key vault.

secretIdentifier
  • string

Key vault secret identifier for fetching secret. Providing a versioned secret will prevent auto-refresh. This requires API Management service to be configured with aka.ms/apimmsi

KeyVaultLastAccessStatusContractProperties

Issue contract Update Properties.

Name Type Description
code
  • string

Last status code for sync and refresh of secret from key vault.

message
  • string

Details of the error else empty.

timeStampUtc
  • string

Last time secret was accessed. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.

NamedValueContract

NamedValue details.

Name Type Description
id
  • string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

name
  • string

The name of the resource

properties.displayName
  • string

Unique name of NamedValue. It may contain only letters, digits, period, dash, and underscore characters.

properties.keyVault

KeyVault location details of the namedValue.

properties.secret
  • boolean

Determines whether the value is a secret and should be encrypted or not. Default value is false.

properties.tags
  • string[]

Optional tags that when provided can be used to filter the NamedValue list.

properties.value
  • string

Value of the NamedValue. Can contain policy expressions. It may not be empty or consist only of whitespace. This property will not be filled on 'GET' operations! Use '/listSecrets' POST request to get the value.

type
  • string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

NamedValueCreateContract

NamedValue details.

Name Type Description
id
  • string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

name
  • string

The name of the resource

properties.displayName
  • string

Unique name of NamedValue. It may contain only letters, digits, period, dash, and underscore characters.

properties.keyVault

KeyVault location details of the namedValue.

properties.secret
  • boolean

Determines whether the value is a secret and should be encrypted or not. Default value is false.

properties.tags
  • string[]

Optional tags that when provided can be used to filter the NamedValue list.

properties.value
  • string

Value of the NamedValue. Can contain policy expressions. It may not be empty or consist only of whitespace. This property will not be filled on 'GET' operations! Use '/listSecrets' POST request to get the value.

type
  • string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"